//Mdulo GLCODE.
//Aqu incluiremos todas las funciones que utilizen OPENGL.
#define _GLCODE_


#include <StdAfx.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <sys/timeb.h>

#include <gl/gl.h>
#include <gl/glut.h>
#include <gl/glaux.h>

#include "glcode.h"
#include "defines.h"

/******************* INICIALIZACION CONTEXTO GRAFICO GL *******************/

/****************************************************************
Funcion en la que inicializamos el contexto de dispositivo:
activamos el color de fondo, iluminaciones o calculos preliminares
Parametros: puntero void que nos permitira pasar cualquier tipo
de datos
Return:nada
***************************************************************/
void inicializacion_gl(void)
{
// Componentes de la iluminacion
GLfloat  ambientLight[] = { 0.2f, 0.2f, 0.2f, 1.0f };
GLfloat  diffuseLight[] = { 0.6f, 0.6f, 0.6f, 1.0f };
GLfloat  specular[] = { 1.0f, 1.0f, 1.0f, 1.0f};
GLfloat	 lightPos[] = { -60.0f, 25.0f, 50.0f, 1.0f };


    glEnable(GL_DEPTH_TEST); /*Activa test de profundidad: para saber qu poligonos hay delante
			     y eliminar superficies ocultas*/
	glDepthFunc(GL_LESS);
    
	glClearColor(0.0f, 0.0f, 0.0f, 1.0f ); //Elige el color de fondo de la ventana

	//Activamos y definimos luces
	glLightfv(GL_LIGHT0,GL_AMBIENT,ambientLight);
	glLightfv(GL_LIGHT0,GL_DIFFUSE,diffuseLight);
	glLightfv(GL_LIGHT0,GL_SPECULAR,specular);
	glLightfv(GL_LIGHT0,GL_POSITION,lightPos);
	// glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);

 
	switch(mode_vis)//Modo de dibujo de los poligonos
	{
	case VIS_LINE:
		glPolygonMode(GL_FRONT_AND_BACK, GL_LINE); 
		break;
	case VIS_FILL:
		glPolygonMode(GL_FRONT_AND_BACK, GL_FILL); 
		break;
	}

	//PROBAR A ACTIVAR EL CULLING
    /* glEnable(GL_CULL_FACE); //INMA ACTIVAR CULLING: PARA QUE SOLO DIBUJE UNA CARA*/
    /*glCullFace(GL_FRONT); //Por defecto el front*/
    
}

/***************************************************************
Funcion que calcula el volumen el volumen de visualizacion y la
informacion de la vista. La llamaremos desde el mensaje WM_SIZE,
o desde glutReshapeFunc
Parmetros:ancho y alto de la ventana
******************************************************************/
void cambia_tamanyo(int w, int h)
{
	GLfloat nRange = 10.0f;

	// Prevent a divide by zero
	if(h == 0)
		h = 1;

		/*DEFINIMOS CARACTERICAS DE DONDE ESTA Y COMO VE EL OBSERVADOR*/
	/*Definimos el area de dibujo (Viewport) dentro de la ventana (en este caso
	le decimos que el area es toda la ventan*/


	  /*INMA:PROBAR A DIBUJAR DOS COSAS EN EL VIEWPORT: poner todo 
     * el codigo de arriba otra vez,  cambiando el viewport por la mitad
     * de la escena glViewport(ancho/2, 0, ancho/, alto);
     * y eliminando del segundo trozo los glClear,  y cambiado el aspecto
     * en gluperspective
     */

	/*Definimosla proyeccion: perspectiva:como se proyectan los datos de los objetos
	sobre nuestra ventana 2D*/

	wide=w;
	height=h;

    glViewport(0, 0, w, h);//INMA: PROBAR A CAMBIAR ESTO: hacerlo mayor y menor
	 

	//Cargamos la matriz de proyeccin y definimos la perspectiva
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();/*Empezamos con matriz identidad:no hay perspectiva*/


	gluPerspective(60.0, (float)w/h, pnear, pfar); //Ponemos matriz de perspectiva
	//  60: angulo de vision
	//  ancho/alto: aspecto. Si queremos que los objetos no se distorsionen
	//	cuando la ventana es mas ancha hay que cambiar el aspecto segun
	//	las proporciones de la ventana.
	//  0.1:distancia cercana (a menor distancia de 0.1 no se dibuja nada
	//  5.0 : distancia lejana ( a mayor distanciano se dibuja nada
	
	/*Cargamos la matriz de modelado e inicializamos el punto de vista*/
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
    glTranslatef(0, 0, -3); 

	/*gluLookAt(eyex,eyey,eyez,centx,centy,centz,0,1,0);*/

	//LLamamos a redibujar escena
    glutPostRedisplay();
}



/************************************************************
Funcion de callback del teclado.
En esta funcin habr que aadir todas las teclas que queramos
que realicen alguna funcin.
**************************************************************/
void eventos_teclado(unsigned char key, int x, int y)
{
static int mode=0;
    switch (key) 
	{	
      case 'a': /*Activa o desactiva la animacion*/
	  case 'A':
		animacionActivada = !animacionActivada;
		break;
	  //Seleccion de objetos.
	  case '3':
		 objeto=O_ESFERA;
	  break; 
    }

glutPostRedisplay();/*Envia evento de redibujado despues de hacer un cambio*/
}
 
/*****************************************************
Funcin que obtiene el tiempo del sistema.
********************************************************/
double getTime(void)
{
 _timeb timeptr;

	_ftime(&timeptr);

    return ((double) timeptr.time + (double) timeptr.millitm * 1E-3	);
}
/***********************************************************
Funcion a la que llama el sistema cuando no tiene nada que hacer
Lo que hacemos es actualizar el angulo de giro segun el tiempo que 
ha transcurrido desde el ultimofotograma
***********************************************************/
void actualizar_CB(void)
{
if (animacionActivada)
{
    double currentTime = getTime(); /*Miratiempo actual*/
    double elapsed = currentTime - lastTime; /*Lo compara con el del ultimo*/

    lastTime = currentTime;

	/*Actualiza la rotacion segun el tiempo transcurrido*/
	/*Si eltiempo transcurrido es muy grand??*/
    rotation += rotationRate * ((elapsed <= 1.0) ? elapsed : 1.0);
    if (rotation >= 360) rotation -= 360;

    glutPostRedisplay();
    }
    
}
/*********************************************
Redibuja la escena.
**********************************************/
void redibujar_escena(void)
{


    glPushMatrix();	/*Creamos una nueva matriz (la rotacion es desde el angulo 0)*/
    glRotated(rotation, 0, 1, 0);//Rotacion en eje y

	//Cargamos matriz de modelado
    glMatrixMode(GL_MODELVIEW);

	/*Dibujamos en el buffer que no se ve(back) y cuando ya esta lo visualizamos en el que
	se ve(front)*/
    glDrawBuffer(GL_BACK);

    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);/*Limpiar el buffer de color y el
														de profundidad*/              
	/*Dibujamos los objetos*/

	dibuja_ejes();//Dibujamos los ejes coordenados
	selecciona_material();
		
	//Aqu llamaremos a la funcin que corresponda
	//para dibujar un objeto u otro

		auxSolidSphere(1.0);


    glPopMatrix();
   
   
	glFlush();
    glutSwapBuffers(); /*Pasamos el buffer back delante*/
}

/*Funcin que selecciona selecciona el material, en funcin
del valor de la variable global 'material'*/
void selecciona_material()
{
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, matYell);	
}
/*************************************************************************
FUNCIONES DE DIBUJO DE OBJETOS.
*************************************************************************/
/********************************************
Dibuja ejes coordenados.
Comentario: utilizad la primitiva GL_LINES
********************************************/
void dibuja_ejes()
{

}

/********************************************
Dibuja un cuadrado
Parmetros:lado
Comentario: utilizad la primitiva GL_POLYGON
********************************************/
void dibuja_cuadrado(float lado)
{
	
}
/********************************************
Dibuja un cubo
Parmetros:lado
Comentario: utilizad la primitiva GL_QUADS
********************************************/
void dibuja_cubo(float lado)
{

}

/********************************************
Dibuja una esfera
Parmetros:radio, numero de divisiones en latitud, div. en longitud
			angulo en longitud y en latitut.
Comentario: utilizad la primitiva GL_TRIANGLE_STRIP. Los angulos
son en radianes.
********************************************/
void Esfera_T_Strip(float radio, int nlatitud , int nlongitud,float anglong,float anglat)
{
 
}
/********************************************
Dibuja un cono
Parmetros:radio, altura y numero de lados.
Comentario: utilizad la primitiva GL_TRIANGLE_FAN. 
********************************************/
void dibuja_cono(float radio,float alto,int numsides)
{

}
/********************************************
Dibuja un cono
Parmetros:numero de lados y radio
Comentario: utilizad la primitiva GL_QUAD_STRIP. 
********************************************/
void dibuja_cilindro(int numSides,int radius)
{
   
}
/********************************************
Dibuja un toro
Parmetros:radio mayor y radio menor
Comentario: utilizad la funcion auxSolidTorus
********************************************/
void dibuja_toro(float radio_may ,float radio_men)
{
	
}
/********************************************
Dibuja una tetera
Parmetros:radio 
Comentario: utilizad la funcion auxSolidTeapot
********************************************/			
void dibuja_tetera(float radio)
{
	auxSolidTeapot(radio);
}


