// glcode.h
// Declarations for external OpenGL module.  These functions are
// defined in glcode.c and are called appropriately by the CView
// derived classes.
//#ifndef __GLCODE__
//#define __GLCODE__
#ifdef _GLCODE_
	//VARIABLES GLOBALES


	float posx=0;
	float posy=0;
	float posz=-2;//Posicion punto de vista
	

	float pnear=0.1f;
	float pfar=5.0;//Posicion plano near y far
	int wide=0; int height=0;//Ancho y alto de la ventana
	
	char mode_act=0;
	int objeto=0;//OBJETO QUE DIBUJAMOS
	int mode_vis=0;//Rejilla o relleno
	
	int material =0;
	GLfloat matYell[4] = { 1.0f, 1.0f, 0.00f, 1.0f };
    GLfloat matBlue[4] = { 0.0f, 0.0f, 1.00f, 1.0f };
	GLfloat matGreen[4] = { 0.0f, 1.0f, 0.00f, 1.0f };

	//Variables para la animacion
	char animacionActivada=0;
	double lastTime = 0.0;		/*Tiempo en el que se dibujo el fotograma anterior*/
	double rotationRate = 360.0 / 8.0;	/*Velocidad de rotacion del cilindro*/
	double rotation = 0.0;		/*Angulo que tiene el cilindro en cada momento*/


	//PROTOTIPOS FUNCIONES
	void inicializacion_gl(void);
	void cambia_tamanyo(int anchura, int altura);
	void eventos_teclado(unsigned char key, int x, int y);
	double getTime(void);
	void actualizar_CB(void);
	void redibujar_escena(void);

	void selecciona_material();
	void dibuja_ejes();
	void dibuja_cuadrado(float lado);
	void dibuja_cubo(float lado);
	void Esfera_T_Strip(float radio, int nlatitud , int nlongitud,float anglong,float anglat);
	void dibuja_cono(float radio,float alto,int numsides);
	void dibuja_cilindro(int numSides,int radius);
	void dibuja_toro(float radio_may ,float radio_men);
	void dibuja_tetera(float radio);
	

#else

		

	extern void inicializacion_gl(void);
	extern void cambia_tamanyo(int anchura, int altura);
	extern void eventos_teclado(unsigned char key, int x, int y);
	extern void redibujar_escena(void);
	extern void actualizar_CB(void);




#endif


